:-module(prim_dynamic,[prim_assertFact/2,prim_retractFact/2,prim_getDynamicKnowledge/1,prim_abortTransaction/1,prim_commitTransaction/2,prim_startTransaction/1,prim_isKnownAtTime/3,abortTransaction/0,initializeDynamic/0]).
:-style_check(-singleton).
:-current_module(prologbasics)->true;use_module('../prologbasics').
:-current_module(basics)->true;use_module('../basics').
:-current_module(version)->true;use_module('../version').
:-current_module(pakcsversion)->true;use_module('../pakcsversion').
:-swi7orHigher->set_prolog_flag(double_quotes,codes);true.
:-dynamic dynamicTime/1,dynamicVersion/3,insideTransaction/0.
dynamicTime(1).
setDynamicVersion(_3186,_3180/_3182,_3190):-(retract(dynamicVersion(_3186,_3180/_3182,_3204))->true;true),asserta(dynamicVersion(_3186,_3180/_3182,_3190)).
prim_assertFact('Dynamic.Dynamic'(_3298),'Prelude.()'):-retract(dynamicTime(_3308)),_3322 is _3308+1,assertz(dynamicTime(_3322)),_3298=..[_3336,_3342,_3348,_3354|_3356],_3384=..[_3336,_3322,0|_3356],assertz(user:_3384),logDynamicEvent(_3342,assertz,_3384).
prim_retractFact('Dynamic.Dynamic'(_3486),_3492):-_3486=..[_3496,_3502,_3508,_3514|_3516],_3544=..[_3496,_3532,_3538|_3516],reloadNewestDynamicVersionOf(_3496),retract(dynamicTime(_3554)),_3568 is _3554+1,assertz(dynamicTime(_3568)),call(user:_3544),isInTimeInterval(_3554,_3532,_3538),!,_3618=..[_3496,_3532,_3554|_3516],retract(user:_3544),!,logDynamicEvent(_3502,retract,_3544),assertz(user:_3618),_3492='Prelude.True'.
prim_retractFact(_3784,'Prelude.False').
prim_getDynamicKnowledge(_3820):-reloadNewestDynamicVersions,dynamicTime(_3824),term2partcall('Dynamic.isKnownAtTime'(_3824),1,_3820),(compileWithSharing(function)->makeShare(_3820,_3846);_3846=_3820).
prim_isKnownAtTime(_3924,'Dynamic.Dynamic'(_3920),'Prelude.True'):-_3920=..[_3932,_3938,_3944,_3950|_3952],_3980=..[_3932,_3968,_3974|_3952],call(user:_3980),isInTimeInterval(_3924,_3968,_3974).
isInTimeInterval(_4072,_4074,_4076):-_4072>=_4074,(_4076=0->true;_4072=<_4076).
logDynamicEvent('Dynamic.Temporary',_4168,_4170):-!.
logDynamicEvent('Dynamic.Persistent',_4226,_4228):-_4228=..[_4232,_4238,_4244|_4246],_4274=..[_4232,0,0|_4246],_4292=..[_4226,_4274],user:dynamicPredInfo(_4232/_4300,_4306),logDynamic(_4292,_4306).
logDynamic(_4396,_4398):-dir2tmplockfile(_4398,_4404),lockWithFileIfNotInTransaction(_4404),executeWithFinalize((dir2logfile(_4398,_4414),open(_4414,append,_4422),writeq(_4422,_4396),put_code(_4422,46),nl(_4422),flush_output(_4422),close(_4422),addChangePid(_4398)),unlockWithFileIfNotInTransaction(_4404)).
executeWithFinalize(_4560,_4562):-on_exception(_4570,_4560,(call(_4562),printError(_4570),!,fail)),!,call(_4562).
executeWithFinalize(_4658,_4660):-call(_4660),!,fail.
prim_startTransaction(_4722):-(insideTransaction->writeErr('ERROR: nested transactions not supported!'),nlErr,!,fail;true),assert(insideTransaction),on_exception(_4784,initTransaction(_4722),(unlockAllPersistentDynamics,(retract(insideTransation)->true;true),printError(_4784),fail)),!.
initTransaction(_4866):-lockAllPersistentDynamics,reloadNewestDynamicVersions,retract(dynamicTime(_4870)),_4866 is _4870+1,assertz(dynamicTime(_4866)),logAllDynamicPreds(startTransaction(_4866)).
prim_commitTransaction(_4970,'Prelude.()'):-logAllDynamicPreds(commitTransaction(_4970)),unlockAllPersistentDynamics,(retract(insideTransaction)->true;true).
prim_abortTransaction(_5054):-logAllDynamicPreds(abortTransaction),getDynamicDirs(_5062),map1partialM(prim_dynamic:addChangePid(0),_5062),unlockAllPersistentDynamics,(retract(insideTransaction)->true;true),!,fail.
getDynamicDirs(_5168):-findall(_5172,isDynamicDir(_5172),_5180),sort(_5180,_5168).
isDynamicDir(_5230):-user:dynamicPredInfo(_5234,_5230),\+_5230=''.
logAllDynamicPreds(_5296):-getDynamicDirs(_5300),map1partialM(prim_dynamic:logDynamic(_5296),_5300).
initializeDynamic:-user:dynamicPredInfo(_5360/_5362,_5368),initializeDynamic(_5368,_5360/_5362),fail.
initializeDynamic.
initializeDynamic('',_5438/_5440):-!,retractAllFacts(_5438/_5440).
initializeDynamic(_5514,_5508/_5510):-existsDirectory(_5514),!,checkDynSpec(_5514,_5508/_5510),setDynamicVersion(_5514,_5508/_5510,0),!.
initializeDynamic(_5616,_5618):-existsFile(_5616),!,appendAtom('ERROR: Directory "',_5616,_5630),appendAtom(_5630,'" for dynamic entries cannot be created!',_5638),writeErr(_5638),nlErr,!,fail.
initializeDynamic(_5736,_5730/_5732):-upDirectory(_5736,_5744),(existsDirectory(_5744)->createDynamicDir(_5736,_5730/_5732),setDynamicVersion(_5736,_5730/_5732,1);writeErr('>>> Warning: persistent dynamic data directory '),writeErr(_5736),writeErr(' not accessible!'),nlErr).
upDirectory('.',..):-!.
upDirectory(_5922,_5924):-atom_codes(_5922,_5930),append(_5940,[47|_5936],_5930),\+member(47,_5936),!,atom_codes(_5924,_5940).
upDirectory(_6030,'.').
checkDynSpec(_6072,_6066/_6068):-dir2specfile(_6072,_6080),existsFile(_6080),readPrologTermFile(_6080,_6090),dynamicSpec(_6066/_6068,_6090),!.
checkDynSpec(_6172,_6174):-appendAtom('ERROR: Directory "',_6172,_6182),appendAtom(_6182,'" contains no matching dynamic entries!',_6190),writeErr(_6190),nlErr,!,fail.
replayLogFile(_6276,_6270/_6272):-dir2tmplockfile(_6276,_6284),lockWithFileIfNotInTransaction(_6284),executeWithFinalize(replayLogFileWhenAlreadyLocked(_6276,_6270/_6272),unlockWithFileIfNotInTransaction(_6284)).
:-dynamic replayStatus/1.
replayLogFileWhenAlreadyLocked(_6392,_6386/_6388):-(pakcsrc(dynamicmessages,yes)->writeErr('>>> Restoring persistent dynamic data in directory \''),writeErr(_6392),writeErr('\'...'),nlErr;true),getRunTime(_6446),ensurePakcsVersion(_6392),dir2dbfile(_6392,_6456),dir2pofile(_6392,_6462),consultPrologorPOFile(_6456,_6462),dir2logfile(_6392,_6474),open(_6474,read,_6482),(atEndOfStream(_6482)->close(_6482);assert(replayStatus(unchanged)),repeat,on_exception(_6512,readAndReplay(_6482),((printError(_6512)->true;true),writeErr('ERROR during reading of '),writeErr(_6474),writeErr(' (restored state might be incomplete)'),nlErr)),close(_6482),retract(replayStatus(_6576)),writeNewDatabaseIfChanged(_6386/_6388,_6392,_6576)),updateDynFactsIfNecessary(_6392,_6386/_6388),readDynamicVersion(_6392,_6648),setDynamicVersion(_6392,_6386/_6388,_6648),writeChangePids(_6392,[]),(pakcsrc(dynamicmessages,yes)->writeErr('>>> ...restored in '),getRunTime(_6682),_6692 is _6682-_6446,writeErr(_6692),writeErr(' msec'),nlErr;true),!.
ensurePakcsVersion(_6874):-readPAKCSVersion(_6874,_6880),_6880=pakcsVersion(_6884,_6886),prologMajor(_6896),\+_6896=_6886,dir2pofile(_6874,_6912),(existsFile(_6912)->deleteFile(_6912);true),writePAKCSVersion(_6874),!.
ensurePakcsVersion(_7016).
isCurrentPakcsVersion(_7042):-readPAKCSVersion(_7042,_7048),compilerVersion(_7052),!,(_7048=compilerVersion(_7052)->writePAKCSVersion(_7042);_7048=pakcsVersion(_7052,_7078)).
readPAKCSVersion(_7146,_7148):-dir2pakcsversionfile(_7146,_7154),existsFile(_7154),readPrologTermFile(_7154,_7148).
writePAKCSVersion(_7222):-dir2pakcsversionfile(_7222,_7228),compilerVersion(_7232),prologMajor(_7236),writePrologTermFile(_7228,pakcsVersion(_7232,_7236)).
updateDynFactsIfNecessary(_7304,_7306):-isCurrentPakcsVersion(_7304),!.
updateDynFactsIfNecessary(_7368,_7362/_7364):-compilerVersion(_7374),(pakcsrc(dynamicmessages,yes)->writeErr('>>> Updating persistent dynamic data in directory \''),writeErr(_7368),writeErr('\' to compiler version '),writeErr(_7374),writeErr(...),nlErr;true),updateDynFacts(_7362/_7364),writeNewDatabaseIfChanged(_7362/_7364,_7368,changed),writePAKCSVersion(_7368).
updateDynFactsIfNecessary(_7540,_7542).
updateDynFacts(_7576/_7578):-functor(_7586,_7576,_7578),functor(_7594,_7576,_7578),retract(user:_7586),arg(1,_7586,_7616),arg(1,_7594,_7616),arg(2,_7586,_7632),arg(2,_7594,_7632),translateDynFactArgs(3,_7578,_7586,_7594),asserta(user:_7594),fail.
updateDynFacts(_7752).
translateDynFactArgs(_7778,_7780,_7782,_7784):-_7778>_7780,!.
translateDynFactArgs(_7858,_7860,_7862,_7864):-arg(_7858,_7862,_7872),translateDynFactArg(_7872,_7878),arg(_7858,_7864,_7878),_7896 is _7858+1,translateDynFactArgs(_7896,_7860,_7862,_7864).
translateDynFactArg(_7994,_7994):-var(_7994),!.
translateDynFactArg(_8052,_8052):-number(_8052),!.
translateDynFactArg('True','Prelude.True'):-!.
translateDynFactArg('False','Prelude.False'):-!.
translateDynFactArg('False','Prelude.False'):-!.
translateDynFactArg('Left','Prelude.Left'):-!.
translateDynFactArg('Right','Prelude.Right'):-!.
translateDynFactArg('Nothing','Prelude.Nothing'):-!.
translateDynFactArg('Just','Prelude.Just'):-!.
translateDynFactArg('LT','Prelude.LT'):-!.
translateDynFactArg('GT','Prelude.GT'):-!.
translateDynFactArg('EQ','Prelude.EQ'):-!.
translateDynFactArg(_8590,_8592):-atomic(_8590),atom_codes(_8590,[40|_8602]),!,appendAtom('Prelude.',_8590,_8592).
translateDynFactArg(_8680,_8682):-atom(_8680),atom_codes(_8680,[39|_8692]),!,(_8692=[_8702]->char_int(_8682,_8702);_8692=[78,85,76]->char_int(_8682,0);writeErr('INTERNAL ERROR in translateDynFactArg: unkown char'),nlErr).
translateDynFactArg(_8844,_8844):-atomic(_8844),!.
translateDynFactArg(_8902,_8904):-functor(_8902,_8910,_8912),translateDynFactArg(_8910,_8918),functor(_8904,_8918,_8912),translateDynFactArgs(1,_8912,_8902,_8904).
writeNewDatabaseIfChanged(_9000/_9002,_9008,changed):-!,dir2dbfile(_9008,_9016),dir2pofile(_9008,_9022),dir2logfile(_9008,_9028),appendAtom(_9016,'.bak',_9036),tell(_9036),writeq((:-dynamic _9000/_9002)),put_code(46),nl,listing(user:_9000/_9002),told,try_save_predicates(_9000/_9002,_9022),renameFile(_9036,_9016),appendAtom(_9028,'.bak',_9104),renameFile(_9028,_9104),appendAtom('touch ',_9028,_9118),shellCmd(_9118),readDynamicVersion(_9008,_9128),_9138 is _9128+1,writeDynamicVersion(_9008,_9138),(pakcsrc(dynamicmessages,yes)->writeErr('>>> ...new database constructed by merging old database and log file '),nlErr;true).
writeNewDatabaseIfChanged(_9348/_9350,_9356,_9358):-dir2logfile(_9356,_9364),appendAtom(_9364,'.bak',_9372),renameFile(_9364,_9372),appendAtom('touch ',_9364,_9386),shellCmd(_9386).
readAndReplay(_9468):-atEndOfStream(_9468),!.
readAndReplay(_9516):-read(_9516,_9522),replayEvent(_9516,_9522).
replayEvent(_9572,end_of_file):-!.
replayEvent(_9624,startTransaction(_9620)):-readAndReplayTransaction(_9624,_9620,[]),!,fail.
replayEvent(_9692,_9694):-retract(replayStatus(_9698)),assert(replayStatus(changed)),call(user:_9694),!,fail.
readAndReplayTransaction(_9790,_9792,_9794):-atEndOfStream(_9790),!,(pakcsrc(dynamicmessages,yes)->writeErr('>>> Warning: ignoring incomplete transaction '),writeErr(_9792),nlErr;true).
readAndReplayTransaction(_9902,_9904,_9906):-read(_9902,_9912),(_9912=commitTransaction(_9904)->callRevList(_9906);_9912=abortTransaction->true;readAndReplayTransaction(_9902,_9904,[_9912|_9906])),!.
callRevList([]).
callRevList([_10062|_10064]):-callRevList(_10064),retract(replayStatus(_10076)),assert(replayStatus(changed)),call(user:_10062).
startTransaction(_10154).
commitTransaction(_10180).
abortTransaction.
lockAllPersistentDynamics:-getDynamicDirs(_10218),map1M(prim_dynamic:lockDynamicDir,_10218).
lockDynamicDir(_10264):-dir2lockfile(_10264,_10270),lockWithFile(_10270).
lockWithFileIfNotInTransaction(_10318):-insideTransaction->true;lockWithFile(_10318).
lockWithFile(_10372):-appendAtom('lockfile-create --lock-name ',_10372,_10380),(existsFile(_10372),pakcsrc(dynamicmessages,yes)->writeErr('>>> Waiting for removing lock file \''),writeErr(_10372),writeErr('\'...'),nlErr;true),shellCmd(_10380),!.
unlockAllPersistentDynamics:-getDynamicDirs(_10498),map1M(prim_dynamic:unlockDynamicDir,_10498).
unlockDynamicDir(_10544):-dir2lockfile(_10544,_10550),unlockWithFile(_10550).
unlockWithFileIfNotInTransaction(_10598):-insideTransaction->true;unlockWithFile(_10598).
unlockWithFile(_10652):-existsFile(_10652),!,appendAtom('lockfile-remove --lock-name ',_10652,_10664),shellCmd(_10664).
unlockWithFile(_10724).
reloadNewestDynamicVersions:-user:dynamicPredInfo(_10750/_10752,_10758),dynamicVersion(_10758,_10750/_10752,_10778),reloadNewestDynamicVersion(_10758,_10750/_10752,_10778),fail.
reloadNewestDynamicVersions.
reloadNewestDynamicVersionOf(_10850):-dynamicVersion(_10860,_10850/_10856,_10864),!,reloadNewestDynamicVersion(_10860,_10850/_10856,_10864).
reloadNewestDynamicVersionOf(_10928).
reloadNewestDynamicVersion(_10960,_10954/_10956,0):-!,retractAllFacts(_10954/_10956),replayLogFile(_10960,_10954/_10956),!.
reloadNewestDynamicVersion(_11064,_11058/_11060,_11068):-readDynamicVersion(_11064,_11074),\+_11068=_11074,!,retractAllFacts(_11058/_11060),replayLogFile(_11064,_11058/_11060),!.
reloadNewestDynamicVersion(_11190,_11192,_11194):-readChangePids(_11190,_11200),currentPID(_11204),(_11200=[];_11200=[_11204]),!.
reloadNewestDynamicVersion(_11306,_11300/_11302,_11310):-retractAllFacts(_11300/_11302),replayLogFile(_11306,_11300/_11302).
createDynamicDir(_11398,_11392/_11394):-(pakcsrc(dynamicmessages,yes)->writeErr('>>> Creating new persistent dynamic data in directory \''),writeErr(_11398),writeErr('\'...'),nlErr;true),appendAtom('mkdir -p ',_11398,_11456),shellCmd(_11456),dir2logfile(_11398,_11466),appendAtom('touch ',_11466,_11474),shellCmd(_11474),dir2dbfile(_11398,_11484),appendAtom('touch ',_11484,_11492),shellCmd(_11492),dir2specfile(_11398,_11502),dynamicSpec(_11392/_11394,_11514),writePrologTermFile(_11502,_11514),writePAKCSVersion(_11398).
readPrologTermFile(_11642,_11644):-open(_11642,read,_11652),read(_11652,_11644),close(_11652).
writePrologTermFile(_11720,_11722):-open(_11720,write,_11730),writeq(_11730,_11722),put_code(_11730,46),nl(_11730),flush_output(_11730),close(_11730).
readDynamicVersion(_11830,_11832):-dir2versionfile(_11830,_11838),existsFile(_11838),!,on_exception(_11858,readPrologTermFile(_11838,_11832),_11832=0).
readDynamicVersion(_11926,1).
writeDynamicVersion(_11962,_11964):-dir2versionfile(_11962,_11970),writePrologTermFile(_11970,_11964).
readChangePids(_12028,_12030):-dir2changepidsfile(_12028,_12036),existsFile(_12036),!,on_exception(_12062,readPrologTermFile(_12036,_12030),_12030=[0]).
readChangePids(_12130,[]).
writeChangePids(_12166,_12168):-dir2changepidsfile(_12166,_12174),writePrologTermFile(_12174,_12168).
addChangePid(_12232):-currentPID(_12236),addChangePid(_12236,_12232).
addChangePid(_12286,_12288):-readChangePids(_12288,_12294),(member(_12286,_12294)->true;writeChangePids(_12288,[_12286|_12294])),!.
dynamicSpec(_12382/_12384,dynamicPredicate(_12382,_12384)).
retractDeadDynamicFacts(_12430/_12432):-length(_12440,_12432),_12452=..[_12430|_12440],_12440=[_12458,_12464|_12466],dynamicTime(_12476),call(user:_12452),_12464>0,_12476>_12464,retract(user:_12452),fail.
retractDeadDynamicFacts(_12594).
dir2logfile(_12620,_12622):-appendAtom(_12620,'/eventlog',_12622).
dir2lockfile(_12676,_12678):-appendAtom(_12676,'/LOCK',_12678).
dir2tmplockfile(_12732,_12734):-appendAtom(_12732,'/LOCK',_12734).
dir2dbfile(_12788,_12790):-appendAtom(_12788,'/database.pl',_12790).
dir2pofile(_12844,_12846):-appendAtom(_12844,'/dbpred.po',_12846).
dir2specfile(_12900,_12902):-appendAtom(_12900,'/spec',_12902).
dir2pakcsversionfile(_12956,_12958):-appendAtom(_12956,'/pakcsversion',_12958).
dir2versionfile(_13012,_13014):-appendAtom(_13012,'/version',_13014).
dir2changepidsfile(_13068,_13070):-appendAtom(_13068,'/changepids',_13070).
